# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from novatel_gps_msgs/Time.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class Time(genpy.Message):
  _md5sum = "65d339585d71de8242304ff93e8a4f1a"
  _type = "novatel_gps_msgs/Time"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# Parsed Best Position or Omnistar XP or HP pos data from Novatel OEM6 receiver
Header header

# Clock model status
# see Table 65 on pg 322 of the OEM6 Family Firmware Reference Manual, Rev3
string clock_status

# Receiver clock offset, in seconds, from GPS reference time. A positive offset
# implies that the receiver clock is ahead of GPS reference time. To derive
# GPS reference time, use the following formula:
# GPS reference time = receiver time - offset
float64 offset

# Standard deviation of the offset
float64 offset_std

# The offset of the GPS reference time from UTC time, computed using almanac
# parameters. UTC time is GPS reference time plus the current UTC offset plus
# the receiver clock offset:
# UTC time = GPS reference time + offset + UTC offset
float64 utc_offset

uint32 utc_year
uint8 utc_month
uint8 utc_day
uint8 utc_hour
uint8 utc_minute
uint32 utc_millisecond

string utc_status
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id
"""
  __slots__ = ['header','clock_status','offset','offset_std','utc_offset','utc_year','utc_month','utc_day','utc_hour','utc_minute','utc_millisecond','utc_status']
  _slot_types = ['std_msgs/Header','string','float64','float64','float64','uint32','uint8','uint8','uint8','uint8','uint32','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,clock_status,offset,offset_std,utc_offset,utc_year,utc_month,utc_day,utc_hour,utc_minute,utc_millisecond,utc_status

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Time, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.clock_status is None:
        self.clock_status = ''
      if self.offset is None:
        self.offset = 0.
      if self.offset_std is None:
        self.offset_std = 0.
      if self.utc_offset is None:
        self.utc_offset = 0.
      if self.utc_year is None:
        self.utc_year = 0
      if self.utc_month is None:
        self.utc_month = 0
      if self.utc_day is None:
        self.utc_day = 0
      if self.utc_hour is None:
        self.utc_hour = 0
      if self.utc_minute is None:
        self.utc_minute = 0
      if self.utc_millisecond is None:
        self.utc_millisecond = 0
      if self.utc_status is None:
        self.utc_status = ''
    else:
      self.header = std_msgs.msg.Header()
      self.clock_status = ''
      self.offset = 0.
      self.offset_std = 0.
      self.utc_offset = 0.
      self.utc_year = 0
      self.utc_month = 0
      self.utc_day = 0
      self.utc_hour = 0
      self.utc_minute = 0
      self.utc_millisecond = 0
      self.utc_status = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.clock_status
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_3dI4BI().pack(_x.offset, _x.offset_std, _x.utc_offset, _x.utc_year, _x.utc_month, _x.utc_day, _x.utc_hour, _x.utc_minute, _x.utc_millisecond))
      _x = self.utc_status
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.clock_status = str[start:end].decode('utf-8')
      else:
        self.clock_status = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.offset, _x.offset_std, _x.utc_offset, _x.utc_year, _x.utc_month, _x.utc_day, _x.utc_hour, _x.utc_minute, _x.utc_millisecond,) = _get_struct_3dI4BI().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.utc_status = str[start:end].decode('utf-8')
      else:
        self.utc_status = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.clock_status
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_3dI4BI().pack(_x.offset, _x.offset_std, _x.utc_offset, _x.utc_year, _x.utc_month, _x.utc_day, _x.utc_hour, _x.utc_minute, _x.utc_millisecond))
      _x = self.utc_status
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.clock_status = str[start:end].decode('utf-8')
      else:
        self.clock_status = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.offset, _x.offset_std, _x.utc_offset, _x.utc_year, _x.utc_month, _x.utc_day, _x.utc_hour, _x.utc_minute, _x.utc_millisecond,) = _get_struct_3dI4BI().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.utc_status = str[start:end].decode('utf-8')
      else:
        self.utc_status = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3dI4BI = None
def _get_struct_3dI4BI():
    global _struct_3dI4BI
    if _struct_3dI4BI is None:
        _struct_3dI4BI = struct.Struct("<3dI4BI")
    return _struct_3dI4BI
